package main

import (
	"fmt"
	"io/fs"
	"os"
	"path"
	"path/filepath"
)

func main() {
	// 获取程序运行当前目录
	fmt.Println(filepath.Abs("."))

	fmt.Println(os.Args)
	fmt.Println(os.Args[0])
	// 获取当前可执行文件的绝对路径
	p, _ := filepath.Abs(os.Args[0])
	fmt.Println(p)

	// 获取文件名
	fmt.Println(path.Base("/etc/hosts"))     // hosts
	fmt.Println(filepath.Base("/etc/hosts")) // hosts
	fmt.Println(filepath.Base("/etc"))       // etc
	// 获取文件父目录
	fmt.Println(filepath.Dir("/etc/hosts")) // /etc
	d := filepath.Dir(p)

	// 获取文件后缀
	fmt.Println(filepath.Ext("/etc/hosts"))   //
	fmt.Println(filepath.Ext("/main.go"))     // .go
	fmt.Println(filepath.Ext("/xianbin.png")) // .png

	// 目录拼接
	fmt.Println(d + "/etc/main.conf")
	fmt.Println(path.Join(d, "etc", "main.conf"))
	home, _ := os.UserHomeDir()
	fmt.Println(path.Join(home, "etc", "main.conf"))

	fmt.Println(filepath.Split("/etc/hosts"))

	// 按文件格式搜索，示例获取当前目录下所有以 .go 结尾的文件
	fmt.Println(filepath.Glob("./*.go"))
	fmt.Println(filepath.Glob("../[ml]*/*.go"))

	// 获取当前路径下所有文件
	filepath.Walk(".", func(path string, info fs.FileInfo, err error) error {
		fmt.Printf("%s %T %#v\n", path, info, info)
		return nil
	})

	// 获取当前路径下所有文件夹
	filepath.WalkDir(".", func(path string, d fs.DirEntry, err error) error {
		fmt.Printf("%s %T %#v %v\n", path, d, d.Name(), d.IsDir())
		return err
	})
}
